﻿Public Class frmMC

    Dim mEnergyData(500) As Double
    Dim mNormInsData(500) As Double
    Dim mEnergyFit(500) As Double
    Dim mNormInsFit(500) As Double
    Dim mNopointsFit As Integer
    Dim mNopointsData As Integer
    Dim mFitfilename As String
    Dim mSpecfilename As String
    Dim mE0 As Double
   

    Private Sub cmdNorm_Click(sender As Object, e As EventArgs) Handles cmdNorm.Click

        Dim i As Integer
        Dim j As Integer
        Dim lstring As String
        Dim location_Renamed As String
        Dim larray(10) As String
        Dim dataind As Boolean

        lblFinished.Visible = False
        CommonDialog1Open.Filter = "Athena LCF files(*.lcf)|*.lcf"
        If CommonDialog1Open.ShowDialog() = Windows.Forms.DialogResult.Cancel Then Exit Sub

        FileOpen(1, CommonDialog1Open.FileName, OpenMode.Input)
        mSpecfilename = CommonDialog1Open.FileName
        lblInfile1.Text = mSpecfilename

        location_Renamed = InStrRev(CommonDialog1Open.FileName, "\")
        CommonDialog1Open.InitialDirectory = Mid(CommonDialog1Open.FileName, 1, location_Renamed - 1)

        lstring = LineInput(1)
        dataind = False
        j = 0

        For i = 1 To 1000
            lstring = LineInput(1)
            If EOF(1) = True Or lstring = vbNullString Or lstring = "" Then
                mNopointsData = j
                Exit For
            End If
            If dataind = True Then
                larray(1) = Mid(lstring, 1, 15)
                larray(2) = Mid(lstring, 16, 19)
                larray(3) = Mid(lstring, 35, 17)
                j = j + 1
                mEnergyData(j) = Val(larray(1))
                mNormInsData(j) = Val(larray(2))
                mNormInsFit(j) = Val(larray(3))
                
            End If
            If Mid(lstring, 1, 14) = "#  energy data" Then
                dataind = True
            End If

        Next i
        FileClose(1)

    End Sub





    Private Sub cmdDoIt_Click(sender As Object, e As EventArgs) Handles cmdDoIt.Click

        Dim app = New Microsoft.Office.Interop.Excel.Application
        Dim wf = app.WorksheetFunction
        Dim random As New Random
        Dim energyout(300) As Double
        Dim norminsout(300) As Double

        Dim normmatrix() As Double
        Dim calmatrix() As Double

        Dim corrnormdev As Double
        Dim i As Integer
        Dim j As Integer
        Dim nosp As Integer
        Dim ecalerr As Double
        Dim energydev As Double
        Dim lhs As Boolean
        Dim lhsint As Double
        Dim location_Renamed As String
        Dim outfile As String
        Dim outfilename As String
        Dim normdev As Double
        Dim noisedev As Double
        Dim normerr As Double
        Dim normlimit As Double
        Dim rnumber As Double
        Dim rnrescaled As Double
       
        Dim pos1 As Integer

        lblFinished.Visible = False
        ecalerr = Val(txtEcalerror.Text)
        nosp = CInt(Val(txtNospectra.Text))
        normerr = Val(txtMaxnormerror.Text)
        normlimit = Val(txtNormlimit.Text)
        mE0 = Val(txtE0.Text)

        Samplingmethod = cboLHS.Text
        If Samplingmethod = "Latin Hypercube Sampling" Then lhs = True Else lhs = False
        Probdist = cboDistribution.Text
        If Probdist = "Beta distribution" Then
            B_Alpha = Val(txtAlpha.Text)
            B_Beta = Val(txtBeta.Text)
        ElseIf Probdist = "Normal distribution" Then
            N_Stddev = Val(txtAlpha.Text)
        End If

        If lhs = True Then
            ReDim normmatrix(nosp)
            ReDim calmatrix(nosp)
            lhsint = 1 / nosp
            Call Sequencegenerator(nosp, normmatrix)
            wait(1)
            Call Sequencegenerator(nosp, calmatrix)

        End If


        CommonDialog1Save.Filter = "Save simulated spectra as CSV files (*.CSV)|*.CSV"

        If CommonDialog1Save.ShowDialog() = Windows.Forms.DialogResult.Cancel Then Exit Sub


        outfile = CommonDialog1Save.FileName
        pos1 = InStr(outfile, ".CSV")

        location_Renamed = InStrRev(CommonDialog1Save.FileName, "\")
        CommonDialog1Save.InitialDirectory = Mid(CommonDialog1Save.FileName, 1, location_Renamed - 1)

        For i = 1 To nosp

            outfilename = Mid(outfile, 1, pos1 - 1) & "_" & Trim(Str(i)) & ".CSV"
            FileOpen(1, outfilename, OpenMode.Output)
            rnumber = random.NextDouble()
            If lhs = True Then
                rnrescaled = rnumber * lhsint
                rnumber = calmatrix(i) + rnrescaled
            End If
            If Probdist = "Beta distribution" Then
                energydev = wf.BetaInv(rnumber, B_Alpha, B_Beta, -ecalerr, ecalerr)
            ElseIf Probdist = "Rectangular distribution" Then
                energydev = rnumber * 2 * ecalerr - ecalerr
            ElseIf Probdist = "Normal distribution" Then
                energydev = wf.NormInv(rnumber, 0, N_Stddev)
            End If
            rnumber = random.NextDouble()
            If lhs = True Then
                rnrescaled = rnumber * lhsint
                rnumber = normmatrix(i) + rnrescaled
            End If

            If Probdist = "Beta distribution" Then
                normdev = wf.BetaInv(rnumber, B_Alpha, B_Beta, -normerr * 0.01, normerr * 0.01)
            ElseIf Probdist = "Rectangular distribution" Then
                normdev = rnumber * 0.02 * normerr - 0.01 * normerr
            ElseIf Probdist = "Normal distribution" Then
                normdev = wf.NormInv(rnumber, 0, normerr * 0.01)
            End If

            noisedev = 0
            For j = 1 To mNopointsData
                energyout(j) = mEnergyData(j) + energydev

                If energyout(j) <= mE0 + normlimit And energyout(j) > mE0 Then

                    corrnormdev = 1 + normdev * (mE0 + normlimit - energyout(j)) / normlimit
                    norminsout(j) = mNormInsData(j) * corrnormdev + noisedev

                ElseIf energyout(j) <= mE0 Then
                    corrnormdev = 1 + normdev
                    norminsout(j) = mNormInsData(j) * corrnormdev + noisedev
                Else
                    norminsout(j) = mNormInsData(j)
                End If

                WriteLine(1, energyout(j), norminsout(j))
            Next j
            If i = 1 Then WriteLine(1, mEnergyData(1), 0)
            FileClose(1)

        Next i

        app.Quit()         ' don't forget to close it when done !
        lblFinished.Visible = True


    End Sub

    Private Sub wait(ByVal seconds As Integer)

        For i As Integer = 0 To seconds

            System.Threading.Thread.Sleep(1000)
            Application.DoEvents()
        Next
    End Sub

    Public Sub Distparameters()

        If cboDistribution.Text = "Beta distribution" Then
            lblAlpha.Visible = True
            lblBeta.Visible = True
            txtAlpha.Visible = True
            txtBeta.Visible = True
            lblAlpha.Text = "Alpha"
            txtAlpha.Text = Str(B_Alpha)
            txtBeta.Text = Str(B_Beta)
            lblEcalerror.Visible = True
            txtEcalerror.Visible = True
            lblEcalerror.Text = "Bound (+/-) used for beta distribution of energy calibration error"
            lblMaxnor.Text = "Max. normalization error at E0 (%)"
        ElseIf cboDistribution.Text = "Rectangular distribution" Then
            lblAlpha.Visible = False
            lblBeta.Visible = False
            txtAlpha.Visible = False
            txtBeta.Visible = False
            lblEcalerror.Visible = True
            txtEcalerror.Visible = True
            lblEcalerror.Text = "Bound (+/-) used for rectangular distribution of energy calibration error"
            lblMaxnor.Text = "Max. normalization error at E0 (%)"
        ElseIf cboDistribution.Text = "Normal distribution" Then
            lblAlpha.Visible = True
            lblBeta.Visible = False
            txtAlpha.Visible = True
            txtBeta.Visible = False
            lblAlpha.Text = "Std dev of energy (eV)"
            txtAlpha.Text = Str(N_Stddev)
            lblEcalerror.Visible = False
            txtEcalerror.Visible = False
            lblMaxnor.Text = "Std error of normalized intensity at E0 (%)"

        End If

    End Sub


    Public Sub Sequencegenerator(ByRef nsp As Integer, ByRef resh() As Double)

        Dim rand = New Random()

        For i = 0 To (nsp - 1)
            resh(i) = i
        Next i

        For counter = 0 To resh.Length - 2

            Dim n = rand.Next(counter + 1)

            Dim temp = resh(counter)
            resh(counter) = resh(n)
            resh(n) = temp

        Next counter

        'Move one step forward

        For i = nsp To 1 Step -1
            resh(i) = (1 / nsp) * resh(i - 1)
        Next i
        resh(0) = 0

        FileClose(1)

    End Sub


    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles cmdBack.Click

        frmMain.Show()
        Me.Close()

    End Sub

   
    Private Sub frmMC_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        cboLHS.Items.Add("Latin Hypercube Sampling")
        cboLHS.Items.Add("Pure Monte-Carlo")
        If Samplingmethod = vbNullString Or Samplingmethod = "Latin Hypercube Sampling" Then
            cboLHS.Text = "Latin Hypercube Sampling"
        Else
            cboLHS.Text = "Pure Monte-Carlo"
        End If
        cboDistribution.Items.Add("Beta distribution")
        cboDistribution.Items.Add("Rectangular distribution")
        cboDistribution.Items.Add("Normal distribution")

        If Probdist = vbNullString Or Probdist = "Beta distribution" Then
            cboDistribution.Text = "Beta distribution"
        Else
            cboDistribution.Text = Probdist
        End If
        Call Distparameters()


    End Sub

    
   
    Private Sub cboDistribution_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cboDistribution.SelectedIndexChanged

        Call Distparameters()

    End Sub

    Private Sub NotifyIcon9_MouseDoubleClick(sender As Object, e As MouseEventArgs) Handles NotifyIcon9.MouseDoubleClick

    End Sub

    Private Sub NotifyIcon11_MouseDoubleClick(sender As Object, e As MouseEventArgs) Handles NotifyIcon11.MouseDoubleClick

    End Sub

    Private Sub NotifyIcon12_MouseDoubleClick(sender As Object, e As MouseEventArgs) Handles NotifyIcon12.MouseDoubleClick

    End Sub
End Class