﻿Public Class frmResults

    Dim mBasefilename As String
    Dim mChosenmodel As String

    Dim mFilesfolder As String
    Dim mNorefinfile As Integer
    Dim mNospectra As Integer
    Dim mFullfilename_LCF As String
    Dim mNoref As Integer
    Dim mSamplefolder As String
    Dim mStartval As Integer

    Dim mFirstenergy As Double
    Dim mReferencename(30) As String
    Dim mRefgroup(30) As String
    Dim mGroupid() As String


    Private Sub frmResults_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        OpenFileDialog1.InitialDirectory = Fullfilename
        txtFolderSample.Text = Fullfilename
        If My.Computer.FileSystem.FileExists(Fullfilename) = False Then
            MsgBox("Cannot find the file shown in the text box. Please select an other file using the Browse button", 16, "AthenaAut Error")
            Exit Sub
        End If

        Call FindFirstEnergy(Fullfilename)

    End Sub

    Private Sub cmdGroups_Click(sender As Object, e As EventArgs) Handles cmdGroups.Click

        frmGroups.Show()

    End Sub

    Private Sub cmdEvaluate_Click(sender As Object, e As EventArgs) Handles cmdEvaluate.Click

        Call Calcstatreport("evaluate")

    End Sub

    Private Sub AssociateGroups()

        Dim groupfile As String
        Dim u As Integer
        Dim sstr As String

        'This procedure populates two 1-D global arrays to associate a reference with a given group.
        'The information required is stored in the file Standardgroups.txt, which needs to be in the sample folder

        groupfile = My.Computer.FileSystem.SpecialDirectories.MyDocuments & "\Standardgroups.txt"
        If System.IO.File.Exists(groupfile) = False Then
            MsgBox("Cannot find the file Standardgroups.txt. This file should be in your My Documents folder", 16, "AthenaAut Error")
            Exit Sub

        End If
        mNorefinfile = 0
        FileOpen(2, groupfile, OpenMode.Input)
        FileSystem.Input(2, sstr)
        For u = 1 To 50
            If EOF(2) = True Then Exit For
            FileSystem.Input(2, mReferencename(u))
            FileSystem.Input(2, mRefgroup(u))
            If chkMergeFeAl.Checked = True Then
                If mRefgroup(u) = "FeIII phosphate" Or mRefgroup(u) = "P ads to FeIII" Or mRefgroup(u) = "Al phosphate" Or mRefgroup(u) = "P ads to Al" Then
                    mRefgroup(u) = "Fe- and Al-bound P"
                End If
            ElseIf chkMergeFe.Checked = True Or chkMergeAl.Checked = True Then
                If chkMergeAl.Checked = True Then
                    If mRefgroup(u) = "Al phosphate" Or mRefgroup(u) = "P ads to Al" Then
                        mRefgroup(u) = "Al-bound P"
                    End If
                End If
                If chkMergeFe.Checked = True Then
                    If mRefgroup(u) = "FeIII phosphate" Or mRefgroup(u) = "P ads to FeIII" Then
                        mRefgroup(u) = "FeIII-bound P"
                    End If
                End If
            End If

            mNorefinfile = mNorefinfile + 1

        Next u
        FileClose(2)


    End Sub
    Public Function IsExcelRunning() As Boolean

        Dim oApp As Object

        On Error Resume Next

        oApp = GetObject(, "Excel.Application")

        IsExcelRunning = (Err.Number = 0)
        oApp = Nothing
        Err.Clear()

    End Function

    Public Sub Calcstatreport(ByRef calledfrom As String)

        Dim accsum(4) As Double
        Dim currfile As String
        Dim evalue As Double
        Dim excelrunning As Boolean
        Dim highestval As Integer
        Dim i As Integer
        Dim ipstring As String
        Dim j As Integer
        Dim j2 As Integer
        Dim j3 As Integer
        Dim j4 As Integer
        Dim k As Integer
        Dim modelno As Integer
        Dim modstring As String
        Dim msg As String
        Dim n As Integer
        Dim n2 As Integer
        Dim n3 As Integer
        Dim noadd As Integer
        Dim nochars As Integer
        Dim noutgroups As Integer
        Dim nr As Integer
        Dim oApp As Object
        Dim oBook As Object

        Dim avg(4) As Double
        Dim sumofsquaresofdiff(4) As Double
        Dim infomsg As String
        Dim outfile As String
        Dim outopt As Integer
        Dim outpgroup(4) As String
        Dim pos1 As Integer
        Dim pos2 As Integer
        Dim pstring As String
        Dim rfound As Boolean
        Dim reval As Double
        Dim ref As String
        Dim refid As Integer
        Dim rowno As Integer
        Dim sdoub1 As Double
        Dim sdoub1old As Double
        Dim sdoub2 As Double
        Dim srow As Integer
        Dim sumall As Double
        Dim stdeviation(4) As Double
        Dim groups() As String
        Dim gidfreq(20) As Integer
        Dim gidlist(20) As String
        Dim grouplist(20) As String
        Dim refname(30) As String
        Dim refgroups_resorted(30) As String
        Dim refval(,) As Double
        Dim rfact() As Double
        Dim specexist() As Boolean
        Dim sum() As Double
        Dim evaldiff() As Double
        Dim wlmax() As Double

        If InStr(txtFolderSample.Text, "\CopiedCSVs\") > 0 Then
            MsgBox("Do not select files from only the CopiedCSVs folder. Please instead choose the first spectrum from the root folder", 16, "AthenaAut Error")
            Exit Sub
        End If
        infomsg = vbNullString
        pos1 = InStr(txtFolderSample.Text, ".CSV")
        pos2 = InStrRev(txtFolderSample.Text, "\", -1)
        'mAthenapath = txtAthenapath.Text
        Fullfilename = txtFolderSample.Text
        mSamplefolder = txtFolderSample.Text
        mBasefilename = Fullfilename.Substring(0, pos1 - 3)
        mBasefilename = Mid(mBasefilename, pos2 + 1)
        mSamplefolder = mSamplefolder.Substring(0, pos2 - 1)
        mFullfilename_LCF = Fullfilename & ".lcf"

        mStartval = CInt(Val(txtStartVal.Text))
        mNospectra = CInt(Val(txtNospectra.Text))

        mNoref = CInt(Val(txtNorefs.Text))

        If mFirstenergy = 0 And txtFirstenergy.Visible = True Then
            mFirstenergy = Val(txtFirstenergy.Text)
            If mFirstenergy = 0 Then
                MsgBox("Please provide the first energy", 16, "AthenaAut Error")
                Exit Sub
            End If
        End If

        ReDim refval(mNoref, mNospectra)
        ReDim sum(mNospectra)
        ReDim evaldiff(mNospectra)
        ReDim rfact(mNospectra)
        ReDim wlmax(mNospectra)
        ReDim specexist(mNospectra)
        ReDim mGroupid(mNospectra)

        n = mStartval - 1

        'nr is the current number of references found
        nr = 0

        If calledfrom = "assemble2" Then
            outopt = 1
        Else
            outopt = 0
        End If

        For i = 1 To mNospectra
            n = n + 1

            If calledfrom = "evaluate" Or calledfrom = "assemble1" Then
                currfile = mSamplefolder & "\" & mBasefilename & "_" & Trim(Str(n)) & ".CSV.lcf"
            ElseIf calledfrom = "assemble2" Then
                currfile = mSamplefolder & "\CopiedCSVs\" & mBasefilename & "_" & Trim(Str(n)) & ".CSV.lcf"

            End If
            If System.IO.File.Exists(currfile) = True Then
                specexist(i) = True
            ElseIf calledfrom = "assemble2" Then
                currfile = mSamplefolder & "\" & mBasefilename & "_" & Trim(Str(n)) & ".CSV.lcf"
                If System.IO.File.Exists(currfile) = True Then
                    specexist(i) = True
                Else
                    specexist(i) = False
                    GoTo nexti
                End If
            Else
                specexist(i) = False
                GoTo nexti
            End If
            FileOpen(1, currfile, OpenMode.Input)
            For j = 1 To 10000
                If EOF(1) = True Then GoTo Errhandler

                ipstring = LineInput(1)
                If InStr(ipstring, "R-factor") > 0 Then
                    pstring = Mid(ipstring, 14, 9)
                    rfact(i) = Val(pstring)
                    ipstring = LineInput(1)
                    ipstring = LineInput(1)
                    ipstring = LineInput(1)
                    ipstring = LineInput(1)
                    For j2 = 1 To 5
                        ipstring = LineInput(1)
                        If Trim(Mid(ipstring, 7, 9)) = "sum" Then Exit For
                        pstring = Mid(ipstring, 7, 22)
                        ref = Trim(pstring)
                        nochars = Len(ref)
                        If nochars >= 21 Then noadd = nochars - 20 Else noadd = 0
                        pstring = Mid(ipstring, 29 + noadd, 5)
                        reval = Val(pstring)
                        rfound = False
                        For j3 = 1 To nr
                            If ref = refname(j3) Then
                                rfound = True
                                refval(j3, i) = reval
                            End If
                        Next j3
                        If rfound = False Then
                            nr = nr + 1
                            refname(nr) = ref
                            refval(nr, i) = reval
                        End If
                    Next j2
                    pstring = Mid(ipstring, 29, 5)
                    sum(i) = Val(pstring)
                    Exit For
                End If

            Next j
            FileClose(1)
            currfile = mSamplefolder & "\" & mBasefilename & "_" & Trim(Str(n)) & ".CSV"
            FileOpen(1, currfile, OpenMode.Input)
            FileSystem.Input(1, evalue)
            FileSystem.Input(1, wlmax(i))
            For j = 1 To 150
                FileSystem.Input(1, sdoub1)
                FileSystem.Input(1, sdoub2)
                If sdoub1 > 2156 Then Exit For
                If sdoub2 > wlmax(i) Then wlmax(i) = sdoub2
            Next j

            FileClose(1)
            evaldiff(i) = evalue - mFirstenergy

nexti:
        Next i

        'Time to sort if required

        If chkSort.Checked = True Then
            'Start by associating references with groups
            Call AssociateGroups()
            'Then create a resorted array with the groups
            For j = 1 To nr
                For k = 1 To mNorefinfile
                    If mReferencename(k) = refname(j) Then
                        refgroups_resorted(j) = mRefgroup(k)
                    End If
                Next k
            Next j

            'We also need to create a group list
            n2 = 1
            grouplist(1) = refgroups_resorted(1)

            For j = 2 To nr

                For k = 1 To (j - 1)
                    If refgroups_resorted(j) = grouplist(k) Then GoTo nextj
                Next k
                n2 = n2 + 1
                grouplist(n2) = refgroups_resorted(j)
nextj:
            Next j

            ReDim groups(n2)

            n3 = 0
            For i = 1 To 20
                gidfreq(i) = 0
            Next i

            For i = 1 To mNospectra
                For k = 1 To n2
                    groups(k) = "0"
                Next k
                For j = 1 To nr
                    If refval(j, i) > 0 Then
                        For k = 1 To n2
                            If refgroups_resorted(j) = grouplist(k) Then
                                groups(k) = "1"
                            End If
                        Next k
                    End If
                Next j
                mGroupid(i) = vbNullString
                For k = 1 To n2
                    mGroupid(i) = mGroupid(i) & groups(k)
                Next k
                For j = 1 To n3
                    If mGroupid(i) = gidlist(j) Then
                        gidfreq(j) = gidfreq(j) + 1
                        GoTo nextline
                    End If
                Next j
                n3 = n3 + 1
                gidlist(n3) = mGroupid(i)
                gidfreq(n3) = 1
nextline:
            Next i


            modelno = 0
            rowno = 1
nextmodel:
            highestval = 0

            For i = 1 To n3
                If gidfreq(i) > highestval Then
                    highestval = gidfreq(i)
                    refid = i
                End If
            Next i


            If calledfrom = "evaluate" Then
                If highestval = 0 Then GoTo jumptohere
                gidfreq(refid) = 0
            End If

            modelno = modelno + 1
            If calledfrom = "evaluate" And modelno > 1 Then
                rowno = rowno + srow
                For i = 1 To 4
                    sumofsquaresofdiff(i) = 0
                    accsum(i) = 0
                Next i
            End If

            If calledfrom = "assemble1" Then
                msg = "Frequency of the most common combination of reference groups = " & Trim(Str(highestval) & ". If you want to merge/unmerge Fe and Al before inspecting the results, click Cancel")

                Dim result As Integer = MsgBox(msg, MsgBoxStyle.OkCancel, "AthenaAut message")
                If result = DialogResult.Cancel Then
                    Exit Sub

                End If
            End If


            'Go back and calculate statistics. First identify the groups
            j = 0 : noutgroups = 0
            For i = 1 To n2
                j = j + 1
                If Mid(gidlist(refid), j, 1) = "1" Then
                    noutgroups = noutgroups + 1
                    outpgroup(noutgroups) = grouplist(i)
                End If
            Next i

            '1. Sum to calculate averages
            'outopt = 1, calculate averages and stdevs based on the whole population
            'outopt = 0, calculate avgs and stdevs for the most common group only


            For i = 1 To mNospectra
                If gidlist(refid) = mGroupid(i) Or outopt = 1 Then
                    For j = 1 To nr
                        For k = 1 To noutgroups
                            If refgroups_resorted(j) = outpgroup(k) Then
                                accsum(k) = accsum(k) + (refval(j, i) / sum(i))
                            End If
                        Next k
                    Next j

                End If

            Next i

            For k = 1 To noutgroups
                If outopt = 0 Then
                    avg(k) = accsum(k) / highestval
                ElseIf outopt = 1 Then
                    avg(k) = accsum(k) / mNospectra
                End If
            Next k

            '2. Go back and calculate sum of squared differences

            For i = 1 To mNospectra
                If gidlist(refid) = mGroupid(i) Or outopt = 1 Then
                    For k = 1 To noutgroups
                        accsum(k) = 0
                    Next k
                    For j = 1 To nr
                        For k = 1 To noutgroups
                            If refgroups_resorted(j) = outpgroup(k) Then
                                accsum(k) = accsum(k) + (refval(j, i) / sum(i))
                            End If
                        Next k
                    Next j
                    For k = 1 To noutgroups
                        sumofsquaresofdiff(k) = sumofsquaresofdiff(k) + (accsum(k) - avg(k)) ^ 2
                    Next k
                End If
            Next i

            For k = 1 To noutgroups
                If outopt = 0 Then
                    stdeviation(k) = System.Math.Sqrt(sumofsquaresofdiff(k) / highestval)
                ElseIf outopt = 1 Then
                    stdeviation(k) = System.Math.Sqrt(sumofsquaresofdiff(k) / mNospectra)

                End If
            Next k

        End If



        'OK now it is time to write all results to file

        n = mStartval - 1
        srow = noutgroups + 4
        sumall = 0
        For i = 1 To noutgroups
            sumall = sumall + avg(i)
        Next i
        If outopt = 1 Then
            If sumall < 0.999 Then
                sumall = sumall * 100
                infomsg = "The sum of all percentages in the statistical summary is only " & Trim(Str(sumall)) & " %. Please check that the selected groups agree with the references in the output!"
            End If
        End If

        If modelno > 1 Then GoTo skipexcelinit

        'On Error GoTo ExcelError
        excelrunning = IsExcelRunning()

        If Not excelrunning Then
            oApp = CreateObject("Excel.Application")
        Else
            oApp = GetObject(, "Excel.Application")
        End If
        oApp.Visible = True
        oApp.UserControl = True


        Dim oldCI As System.Globalization.CultureInfo = _
                System.Threading.Thread.CurrentThread.CurrentCulture
        System.Threading.Thread.CurrentThread.CurrentCulture = _
            New System.Globalization.CultureInfo("en-US")

        oBook = oApp.Workbooks.Add

        Dim oSheet As Object = oBook.Worksheets(1)



        'Start by presenting statistics


skipexcelinit:
        modstring = "Model" & " " & Trim(Str(modelno))
        If calledfrom = "evaluate" Then oSheet.Cells(rowno, 1).Value = modstring
        If outopt = 0 Then
            oSheet.Cells(rowno, 2).Value = "Frequency"
            oSheet.Cells(rowno, 3).Value = highestval
        ElseIf outopt = 1 Then
            oSheet.Cells(rowno, 2).Value = "Overall statistics"
        End If
        
        oSheet.Cells(rowno + 1, 1).Value = "Statistics"
        oSheet.Cells(rowno + 1, 3).Value = "Reference"
        oSheet.Cells(rowno + 1, 4).Value = "Average %"
        oSheet.Cells(rowno + 1, 5).Value = "Std deviation"

        j4 = 0
        For i = (rowno + 2) To (rowno + noutgroups + 1)
            j4 = j4 + 1
            oSheet.Cells(i, 3).Value = outpgroup(j4)
            oSheet.Cells(i, 4).Value = avg(j4) * 100
            oSheet.Cells(i, 5).Value = stdeviation(j4) * 100
        Next i

        If calledfrom = "evaluate" Then GoTo nextmodel

        'Write headers

        oSheet.Cells(srow, 1).Value = "Spectrum no."
        oSheet.Cells(srow, 2).Value = "Delta-E0"
        oSheet.Cells(srow, 3).Value = "R factor"
        oSheet.Cells(srow, 4).Value = "Sum of weights"
        oSheet.Cells(srow, 5).Value = "WL max at:"
        For j = 1 To nr
            oSheet.Cells(srow, j + 5).Value = refname(j)
        Next j

        For i = 1 To mNospectra
            n = n + 1
            oSheet.Cells(srow + i, 1).Value = n
            If specexist(i) = False Then GoTo nexti2
            oSheet.Cells(srow + i, 2).Value = evaldiff(i)
            oSheet.Cells(srow + i, 3).Value = rfact(i)
            oSheet.Cells(srow + i, 4).Value = sum(i)
            oSheet.Cells(srow + i, 5).Value = wlmax(i)
            For j = 6 To (nr + 5)
                oSheet.Cells(srow + i, j).Value = refval(j - 5, i)
            Next j
            If outopt = 0 Then
                If gidlist(refid) = mGroupid(i) Then
                    oSheet.Cells(srow + i, 1).Interior.Color = Color.Yellow
                End If
            End If
            
nexti2:
        Next i

        If calledfrom = "assemble1" Then mChosenmodel = gidlist(refid)


jumptohere:
        For i = 1 To (5 + nr)
            oSheet.Columns(i).Autofit()
        Next i

        oSheet = Nothing
        oBook = Nothing
        System.Threading.Thread.CurrentThread.CurrentCulture = oldCI

        If outopt = 1 Then
            If infomsg <> vbNullString Then MsgBox(infomsg, , "Note!")
        End If

        If calledfrom = "assemble1" Then cmdCopyCSV.Visible = True


Errhandler:

        FileClose()
        Exit Sub

ExcelError:
        If Err.Number <> 0 Then
            msg = "Error # " & Str(Err.Number) & " was generated by " & Err.Source & Chr(13) & Err.Description
            MsgBox(msg, , "Error")
        End If
        FileClose()




    End Sub

    Private Sub NotifyIcon1_MouseDoubleClick(sender As Object, e As MouseEventArgs) Handles NotifyIcon1.MouseDoubleClick

    End Sub


    Private Sub cmdAssemble_Click(sender As Object, e As EventArgs) Handles cmdAssemble.Click

        Call Calcstatreport("assemble1")

    End Sub

    Private Sub cmdAssemble2_Click(sender As Object, e As EventArgs) Handles cmdAssemble2.Click

        Call Calcstatreport("assemble2")

    End Sub

    Private Sub cmdCopyCSV_Click(sender As Object, e As EventArgs) Handles cmdCopyCSV.Click

        Dim i As Integer
        Dim currfile As String
        Dim destinfile As String
        Dim newfolder As String
        Dim pos1 As Integer
        Dim pos2 As Integer

        pos1 = InStr(txtFolderSample.Text, ".CSV")
        pos2 = InStrRev(txtFolderSample.Text, "\", -1)
        mSamplefolder = txtFolderSample.Text
        mSamplefolder = mSamplefolder.Substring(0, pos2 - 1)

        newfolder = mSamplefolder & "\CopiedCSVs"
        If (Not System.IO.Directory.Exists(newfolder)) Then
            System.IO.Directory.CreateDirectory(newfolder)
        End If



        For i = 1 To mNospectra
            'Delete any previous files if any
            destinfile = newfolder & "\" & mBasefilename & "_" & Trim(Str(i)) & ".CSV"
            If System.IO.File.Exists(destinfile) = True Then
                System.IO.File.Delete(destinfile)
            End If

            If mGroupid(i) <> mChosenmodel Then
                currfile = mSamplefolder & "\" & mBasefilename & "_" & Trim(Str(i)) & ".CSV"
                System.IO.File.Copy(currfile, destinfile)

            End If
        Next i
        lblFinished.Visible = True

    End Sub

    Private Sub cmdBrowseSample_Click(sender As Object, e As EventArgs) Handles cmdBrowseSample.Click

        Dim lastchar As String
        Dim check As Boolean
        Dim posunderscore As Integer
        Dim firstscanname As String
        Dim str1 As String
        Dim str2 As String
        Dim str3 As String
        Dim slashpos As Integer
        Dim slashpos2 As Integer
        Dim strlength As Integer

        OpenFileDialog1.Filter = "Comma-delimeted, normalized, XANES data (*.CSV)|*.CSV"
        If OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.Cancel Then Exit Sub
        strlength = Len(OpenFileDialog1.FileName)
        lastchar = Mid(OpenFileDialog1.FileName, strlength - 4, 1)

        check = IsNumeric(lastchar)

        If check = False Then
            MsgBox("File name incorrect - it should end with a number", 16, "AthenaAut Error")
            Exit Sub
        End If

        cmdCopyCSV.Visible = False
        lblFinished.Visible = False

        txtFolderSample.Text = OpenFileDialog1.FileName
        Fullfilename = txtFolderSample.Text

        posunderscore = InStrRev(Fullfilename, "_")
        firstscanname = Mid(Fullfilename, 1, posunderscore) & "1.CSV"
        slashpos = InStrRev(firstscanname, "\")
        If slashpos <> 0 Then
            str1 = Mid(firstscanname, slashpos + 1)
            slashpos2 = InStrRev(firstscanname, "\", slashpos - 1)
            str3 = Mid(firstscanname, slashpos2 + 1, 10)
            If str3 = "CopiedCSVs" Then
                If slashpos2 <> 0 Then
                    str2 = Mid(firstscanname, 1, slashpos2)
                    firstscanname = str2 & str1
                End If
            End If
            
        End If
        

        Call FindFirstEnergy(firstscanname)



    End Sub

    Public Sub FindFirstEnergy(ByRef currfile As String)

        Dim sdoub1 As Double
        Dim sdoub2 As Double
        Dim sdoubold As Double

        sdoubold = 0
        mFirstenergy = 0

        FileOpen(22, currfile, OpenMode.Input)
        For j = 1 To 400
            If EOF(22) = True Then Exit For
            FileSystem.Input(22, sdoub1)
            FileSystem.Input(22, sdoub2)

            If sdoub1 < sdoubold And sdoub2 = 0 Then
                mFirstenergy = sdoub1
            End If

            sdoubold = sdoub1

        Next j

        FileClose(22)

        If mFirstenergy = 0 Then
            txtFirstenergy.Visible = True
            lblFirstenergy.Visible = True
            txtFirstenergy.Text = ""
        Else
            txtFirstenergy.Visible = False
            lblFirstenergy.Visible = False
        End If


    End Sub

    Private Sub cmdSave_Click(sender As Object, e As EventArgs) Handles cmdSave.Click

        frmMain.Show()
        Me.Close()

    End Sub

End Class